name: Build and Push Docker Image

on:
  push:
    branches: [main]

jobs:
  build:
    runs-on: ubuntu-latest

    container:
      image: quay.io/buildah/stable
      options: --security-opt seccomp=unconfined --security-opt apparmor=unconfined --device /dev/fuse:rw --privileged

    env:
      BUILDAH_ISOLATION: chroot
      STORAGE_DRIVER: vfs

    steps:
      - name: Install Node.js
        run: dnf install -y nodejs git

      - uses: actions/checkout@v4

      - name: Login to Registry
        run: buildah login -u ${{ secrets.REGISTRY_USER }} -p ${{ secrets.REGISTRY_PASSWORD }} git.kocoder.xyz

      - name: Buildah Build
        run: |
          buildah build -t ${{ github.sha }} ./Einheit_4/2025_5BHITN_Konstantin_Hintermayer_smarterrent/Dockerfile
          buildah build -t ${{ github.sha }}-tooling -f ./Einheit_4/tooling_container/Dockerfile .
          buildah tag ${{ github.sha }} latest

      - name: Push Docker Images
        run: |
          buildah push ${{ github.sha }} docker://git.kocoder.xyz/kocoded/kocoder_smarterrent:${{ github.sha }}
          buildah push ${{ github.sha }}-tooling docker://git.kocoder.xyz/kocoded/kocoder_smarterrent_init_db:${{ github.sha }}
          buildah push latest docker://git.kocoder.xyz/kocoded/kocoder_smarterrent:latest
